package br.com.ages.mutiraodobemback.controller;

import br.com.ages.mutiraodobemback.dto.*;
import br.com.ages.mutiraodobemback.service.event.IEventService;
import br.com.ages.mutiraodobemback.service.task.ITaskService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/events")
public class EventController {

    private final IEventService service;
    private final ITaskService taskService;

    @Autowired
    public EventController(IEventService service, ITaskService taskService) {
        this.service = service;
        this.taskService = taskService;
    }

    @PostMapping
    public EventResponseDTO save(@RequestBody EventRequestDTO event) {
        return service.save(event);
    }

    @PatchMapping
    public EventResponseDTO update(@RequestBody EventRequestDTO event) {
        return service.update(event);
    }

    @GetMapping
    public List<EventRequestDTO> findAll() {
        return service.findAll();
    }

    @GetMapping("/all-active")
    public List<EventReponseListDTO> findAllActive() {
        return service.findAllActive();
    }

    @GetMapping("/{id}")
    public EventDetailsResponseDTO findById(@PathVariable String id) {
        return this.service.findById(id);
    }

    @PutMapping("/participate-event/{id}")
    public EventDetailsResponseDTO participateEvent(@PathVariable String id) { return this.service.participateEvent(id);
    }

    @GetMapping("/event-details/{id}")
    public EventDetailsResponseDTO findEventDetails(@PathVariable String id) {
        return this.service.findEventDetails(id);
    }

    @PutMapping("/cancel-participate/{id}")
    public EventDetailsResponseDTO cancelParticipate(@PathVariable String id) { return this.service.cancelParticipate(id);
    }


}
