package br.com.ages.mutiraodobemback.controller;

import br.com.ages.mutiraodobemback.dto.TaskDTO;
import br.com.ages.mutiraodobemback.service.task.ITaskService;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/tasks")
public class TaskController {

    private final ITaskService service;

    public TaskController(ITaskService service) {
        this.service = service;
    }

    @PutMapping("/create-task/{id}")
    public void createTask(@PathVariable String id, @RequestBody TaskDTO dto) { this.service.createTask(id, dto);
    }

    @PutMapping("/delete-task/{id}")
    public void deleteTask(@PathVariable String id, @RequestBody TaskDTO dto) { this.service.deleteTask(id, dto);
    }

    @PutMapping("/join-task/{id}")
    public void joinTask(@PathVariable String id, @RequestBody TaskDTO dto) { this.service.joinTask(id, dto);
    }

    @PutMapping("/complete-task/{id}")
    public void completeTask(@PathVariable String id, @RequestBody TaskDTO dto) { this.service.completeTask(id, dto);
    }

    @PutMapping("/leave-task/{id}")
    public void leaveTask(@PathVariable String id, @RequestBody TaskDTO dto) { this.service.leaveTask(id, dto);
    }
}
