package br.com.ages.mutiraodobemback.domain;

import br.com.ages.mutiraodobemback.dto.UserRequestDTO;
import br.com.ages.mutiraodobemback.enums.UserType;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.index.Indexed;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.lang.NonNull;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Document(collection = "users")
public class UserEntity {

    @Id
    private String id;
    @NonNull
    private String name;
    @NonNull
    @Indexed(unique = true)
    private String document;
    @NonNull
    @Indexed(unique = true)
    private String email;
    @NonNull
    private String password;
    @NonNull
    private String role;
    @NonNull
    private UserType type;
    @NonNull
    private boolean active;
    @NonNull
    private String phone;
    @NonNull
    private String image;

    public UserEntity(UserRequestDTO user) {
        this.name = user.getName();
        this.document = user.getDocument();
        this.email = user.getEmail();
        this.type = user.getType();
        this.phone = user.getPhone();
    }
}
