package br.com.ages.mutiraodobemback.dto;

import br.com.ages.mutiraodobemback.domain.EventEntity;
import br.com.ages.mutiraodobemback.domain.TaskEntity;
import br.com.ages.mutiraodobemback.domain.UserEntity;
import com.fasterxml.jackson.annotation.JsonInclude;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDate;
import java.time.LocalTime;
import java.util.List;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_NULL)
public class EventDetailsResponseDTO {

    private String id;
    private String title;
    private String description;
    private LocalDate eventDate;
    private LocalTime eventTime;
    private List<String> images;
    private List<TaskEntity> tasks;
    private String street;
    private String latitude;
    private String longitude;
    private List<UserEntity> volunteer;
    private boolean loggedUserParticipate;
    private double taskProgress;
    private UserEntity user;

    public EventDetailsResponseDTO(EventEntity event) {
        this.id = event.getId();
        this.title = event.getTitle();
        this.description = event.getDescription();
        this.eventDate = event.getStartDate().toLocalDate();
        this.eventTime = event.getStartDate().toLocalTime();
        this.images = event.getImages();
        this.tasks = event.getTasks();
        this.street = event.getAddress().getStreet();
        this.latitude = event.getAddress().getLatitude();
        this.longitude = event.getAddress().getLongitude();
        this.volunteer = event.getVolunteer();
        this.user = event.getUser();
    }

}
