package br.com.ages.mutiraodobemback.dto;

import br.com.ages.mutiraodobemback.domain.EventEntity;
import com.fasterxml.jackson.annotation.JsonInclude;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDate;
import java.time.LocalTime;
import java.util.List;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_NULL)
public class EventReponseListDTO {

    private String id;
    private String title;
    private String description;
    private LocalDate eventDate;
    private LocalTime eventTime;
    private String userName;
    private String userImage;
    private String street;
    private List<String> images;
    private String latitude;
    private String longitude;

    public EventReponseListDTO(EventEntity eventEntity) {
        this.id = eventEntity.getId();
        this.title = eventEntity.getTitle();
        this.description = eventEntity.getDescription();
        this.eventDate = eventEntity.getStartDate().toLocalDate();
        this.eventTime = eventEntity.getStartDate().toLocalTime();
        this.userName = eventEntity.getUser().getName();
        this.userImage = eventEntity.getUser().getImage();
        this.street = eventEntity.getAddress().getStreet();
        this.images = eventEntity.getImages();
        this.latitude = eventEntity.getAddress().getLatitude();
        this.longitude = eventEntity.getAddress().getLongitude();
    }

}
