package br.com.ages.mutiraodobemback.dto;

import br.com.ages.mutiraodobemback.domain.EventEntity;
import br.com.ages.mutiraodobemback.domain.TaskEntity;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDateTime;
import java.util.List;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class EventRequestDTO {

    private String title;
    private String description;
    private String phone;
    private LocalDateTime startDate;
    private LocalDateTime endDate;
    private String street;
    private String latitude;
    private String longitude;
    private List<String> images;
    private List<TaskEntity> tasks;
    private String eventType;

    public EventRequestDTO(EventEntity eventEntity) {
        this.title = eventEntity.getTitle();
        this.street = eventEntity.getAddress().getStreet();
        this.latitude = eventEntity.getAddress().getLatitude();
        this.longitude = eventEntity.getAddress().getLongitude();
        this.startDate = LocalDateTime.now();
        this.endDate = eventEntity.getEndDate();
        this.description = eventEntity.getDescription();
        this.images = eventEntity.getImages();
        this.tasks = eventEntity.getTasks();
        this.eventType = eventEntity.getEventType();
    }
}
