package br.com.ages.mutiraodobemback.security;

import br.com.ages.mutiraodobemback.domain.UserEntity;
import br.com.ages.mutiraodobemback.repository.IUserRepository;
import br.com.ages.mutiraodobemback.util.exceptions.UserNotFoundException;
import lombok.SneakyThrows;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.userdetails.User;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.stereotype.Service;

@Service("userDetailsService")
public class UserDetailsServiceImpl implements UserDetailsService {

    private final IUserRepository repository;

    @Autowired
    public UserDetailsServiceImpl(IUserRepository repository) {
        this.repository = repository;
    }

    @SneakyThrows
    @Override
    public UserDetails loadUserByUsername(String email) {
        UserEntity user = this.repository.findByEmail(email).orElseThrow(UserNotFoundException::new);
        return User.builder()
                .username(user.getEmail())
                .password(user.getPassword())
                .roles(user.getRole())
                .build();
    }

}
