package br.com.ages.mutiraodobemback.service.aws;

import com.amazonaws.auth.profile.ProfileCredentialsProvider;
import com.amazonaws.regions.Regions;
import com.amazonaws.services.s3.AmazonS3;
import com.amazonaws.services.s3.AmazonS3ClientBuilder;
import com.amazonaws.services.s3.model.CannedAccessControlList;
import com.amazonaws.services.s3.model.ObjectMetadata;
import com.amazonaws.services.s3.model.PutObjectRequest;
import com.amazonaws.services.s3.model.S3Object;
import org.springframework.stereotype.Service;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.util.Base64;

@Service
public class AwsService implements IAwsService {

    private final String BUCKET_NAME = "mutirao";
    private final String BASE_PATH = "/images";
    private final Regions CLIENT_REGION = Regions.US_EAST_2;

    public String uploadFileS3(String dataURL, String path, String key) {
        String[] data = dataURL.split(";");
        String type = data[0].split(":")[1];
        String content = data[1].split(",")[1];

        byte[] contents = Base64.getDecoder().decode(content);
        InputStream stream = new ByteArrayInputStream(contents);

        ObjectMetadata meta = new ObjectMetadata();
        meta.setContentLength(contents.length);
        meta.setContentType(type);

        AmazonS3 s3Client = AmazonS3ClientBuilder.standard()
                .withCredentials(new ProfileCredentialsProvider())
                .withRegion(CLIENT_REGION)
                .build();

        s3Client.putObject(new PutObjectRequest(BUCKET_NAME + BASE_PATH + path, key, stream, meta)
                .withCannedAcl(CannedAccessControlList.Private));
        S3Object s3Object = s3Client.getObject(BUCKET_NAME + BASE_PATH + path, key);
        return s3Object.getObjectContent().getHttpRequest().getURI().toString();
    }

}
